## libeconf 0.3.8

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

# Ensure built-in policies from CMake are used, (e.g. improved policies for macOS)
cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})

project(libeconf VERSION 0.3.8
                 DESCRIPTION "Enhanced config file parser, which merges config files placed in several locations into one."
                 LANGUAGES C
                 )

# Set up GNU conventions and standard FHS paths
include(GNUInstallDirs)

# Activate CMake package configuration helpers
include(CMakePackageConfigHelpers)

# Ensure _GNU_SOURCE is available
include(CheckSymbolExists)

# check if _GNU_SOURCE is available

if (NOT _GNU_SOURCE)
    check_symbol_exists(__GNU_LIBRARY__ "features.h" _GNU_SOURCE)

    if (NOT _GNU_SOURCE)
        unset(_GNU_SOURCE CACHE)
        check_symbol_exists(_GNU_SOURCE "features.h" _GNU_SOURCE)
    endif ()
endif ()

if (_GNU_SOURCE)
    add_definitions(-D_GNU_SOURCE)
endif ()


# set the minimum C standard
set(CMAKE_C_STANDARD 11)

# Build Types
set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE}
    CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel SanitizeAddress RelWithDebInfoStrict"
    FORCE
    )

# AddressSanitize
set(CMAKE_C_FLAGS_SANITIZEADDRESS
    "-O2 -g -Wall -fsanitize=address -fno-optimize-sibling-calls -fsanitize-address-use-after-scope -fno-omit-frame-pointer"
    CACHE STRING "Flags used by the C compiler during AddressSanitizer builds."
    FORCE
    )

set(CMAKE_LINK_FLAGS_SANITIZEADDRESS
    "-fsanitize=address"
    CACHE STRING "Flags used by the linker during AddressSanitizer builds."
    FORCE
    )

# RelWithDebInfoStrict
set(CMAKE_C_FLAGS_RELWITHDEBINFOSTRICT
    "-O2 -g -Werror -W -Wall -DXTSTRINGDEFINES -D_FORTIFY_SOURCE=2 -fstack-protector-strong -funwind-tables -fasynchronous-unwind-tables -fstack-clash-protection -Werror=return-type -flto=8 -Wbad-function-cast -Wcast-align -Wcast-qual -Winline -Wmissing-declarations -Wmissing-prototypes -Wnested-externs -Wshadow -Wstrict-prototypes -Wundef"
    CACHE STRING "Flags used by the C compiler during strict RelWithDebInfo builds."
    FORCE
    )

add_subdirectory(lib)
add_subdirectory(example)

# Enable testing
include(CTest)
enable_testing()
add_subdirectory(tests)

=== lib/CMakeLists.txt ===
# Create the library
set(econf_SRCS libeconf.c
               getfilecontents.c
               mergefiles.c
               helpers.c
               keyfile.c
               econf_errString.c
               get_value_def.c
               )

set(econf_HDRS defines.h
               getfilecontents.h
               mergefiles.h
               helpers.h
               keyfile.h
               )

add_library(econf SHARED ${econf_SRCS} ${econf_HDRS} "${PROJECT_SOURCE_DIR}/include/libeconf.h")

target_include_directories(econf PUBLIC
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

set_target_properties(econf PROPERTIES
  SOVERSION ${PROJECT_VERSION_MAJOR}
  VERSION ${PROJECT_VERSION}
  COMPILE_FLAGS "-D_REENTRANT=1"
  C_STANDARD 11
  C_STANDARD_REQUIRED ON
  PUBLIC_HEADER "${PROJECT_SOURCE_DIR}/include/libeconf.h"
  LINK_FLAGS "-Wl,--no-undefined -Wl,--version-script,\"${PROJECT_SOURCE_DIR}/lib/libeconf.map\""
)

# Install the library
configure_file(${PROJECT_SOURCE_DIR}/cmake/libeconf.pc.in ${CMAKE_BINARY_DIR}/libeconf.pc @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/libeconf.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)
install(TARGETS econf
  EXPORT libeconfTargets
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

# Generate and install the exports
export(EXPORT libeconfTargets
  FILE ${CMAKE_BINARY_DIR}/libeconfTargets.cmake
)
install(EXPORT libeconfTargets
  FILE libeconfTargets.cmake
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/libeconf
)
configure_package_config_file(${PROJECT_SOURCE_DIR}/cmake/libeconfConfig.cmake.in
  ${CMAKE_BINARY_DIR}/libeconfConfig.cmake
  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/libeconf
  NO_SET_AND_CHECK_MACRO
  NO_CHECK_REQUIRED_COMPONENTS_MACRO
)
install(FILES
  ${CMAKE_BINARY_DIR}/libeconfConfig.cmake
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/libeconf
)
write_basic_package_version_file(
  ${CMAKE_BINARY_DIR}/libeconfConfigVersion.cmake
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY SameMinorVersion
)
install(FILES
  ${CMAKE_BINARY_DIR}/libeconfConfigVersion.cmake
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/libeconf
)

=== tests/CMakeLists.txt ===
# Set make check target
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

# Set up macro for building and adding tests
macro(BuildAndAddTest TESTNAME)
  if (${TESTNAME} STREQUAL "tst-getconfdirs2")
    add_executable(${TESTNAME} EXCLUDE_FROM_ALL tst-getconfdirs1.c)
  else()
    add_executable(${TESTNAME} EXCLUDE_FROM_ALL ${TESTNAME}.c)
  endif()
  target_link_libraries(${TESTNAME} PRIVATE econf)
  if (${TESTNAME} STREQUAL "tst-getconfdirs1")
    target_compile_options(${TESTNAME} PRIVATE -DTESTSDIR=\"${PROJECT_SOURCE_DIR}/tests/\" -DSUFFIX=\".conf\")
  elseif (${TESTNAME} STREQUAL "tst-getconfdirs2")
    target_compile_options(${TESTNAME} PRIVATE -DTESTSDIR=\"${PROJECT_SOURCE_DIR}/tests/\" -DSUFFIX=\"conf\")
  else()
    target_compile_options(${TESTNAME} PRIVATE -DTESTSDIR=\"${PROJECT_SOURCE_DIR}/tests/\")
  endif()
  add_test(NAME ${TESTNAME} COMMAND ${TESTNAME})
  add_dependencies(check ${TESTNAME})
endmacro()

set(TESTS tst-filedoesnotexit1
          tst-merge1
          tst-merge2
          tst-merge3
          tst-merge4
          tst-merge5
          tst-logindefs1
          tst-logindefs2
          tst-arguments1
          tst-arguments2
          tst-arguments3
          tst-arguments4
          tst-arguments5
          tst-getconfdirs1
          tst-getconfdirs2
          tst-getconfdirs3
          tst-getconfdirs4
          tst-getconfdirs5
          tst-getconfdirs6
          tst-getconfdirs7
          tst-econf_errstring1
          tst-setgetvalues1
          tst-groups1
          tst-groups2
          tst-groups3
          tst-groups4
          tst-parseconfig1
          tst-quote1
          )

foreach (TESTCASE ${TESTS})
  BuildAndAddTest(${TESTCASE})
endforeach()

=== debian/changelog ===
libeconf (0.3.8-1) unstable; urgency=medium

  * Initial release (Closes: #964857)

 -- Andreas Henriksson <andreas@fatal.se>  Sat, 11 Jul 2020 11:04:11 +0200

=== debian/control ===
Source: libeconf
Priority: optional
Maintainer: Andreas Henriksson <andreas@fatal.se>
Build-Depends: debhelper-compat (= 13), meson
Standards-Version: 4.5.0
Section: libs
Homepage: https://github.com/openSUSE/libeconf
Vcs-Browser: https://salsa.debian.org/debian/libeconf
Vcs-Git: https://salsa.debian.org/debian/libeconf.git

Package: libeconf-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libeconf0 (= ${binary:Version}), ${misc:Depends}
Description: parse and manage key=value configuration files - development files
 libeconf is a highly flexible and configureable library to parse and manage
 key=value configuration files. It reads configuration file snippets from
 different directories and builds the final configuration file for the
 application from it.
 .
 The first file is the vendor provided configuration file. There are two
 methods of overriding this vendor settings: copy the file from /usr/vendordir
 to /etc and modify the settings. Alternatively, a directory named
 file.suffix.d/ within /etc can be created, with drop-in files in the form
 name.suffix. This files contain only the changes of the specific settings the
 user is interested in. There can be several such drop-in files, they are
 processed in lexicographic order of their filename.
 .
 This package provides the development files needed at compile-time.

Package: libeconf0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: parse and manage key=value configuration files
 libeconf is a highly flexible and configureable library to parse and manage
 key=value configuration files. It reads configuration file snippets from
 different directories and builds the final configuration file for the
 application from it.
 .
 The first file is the vendor provided configuration file. There are two
 methods of overriding this vendor settings: copy the file from /usr/vendordir
 to /etc and modify the settings. Alternatively, a directory named
 file.suffix.d/ within /etc can be created, with drop-in files in the form
 name.suffix. This files contain only the changes of the specific settings the
 user is interested in. There can be several such drop-in files, they are
 processed in lexicographic order of their filename.
 .
 This package provides the library files needed at runtime.

=== debian/watch ===
version=4

# PGP signature mangle, so foo.tar.gz has foo.tar.gz.sig
#opts="pgpsigurlmangle=s%$%.sig%"

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%libeconf-$1.tar.gz%" \
   https://github.com/openSUSE/libeconf/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## libeconf 0.4.6+dfsg1

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -33,6 +33,10 @@
           tst-arguments3
           tst-arguments4
           tst-arguments5
+	  tst-string
+	  tst-string-append
+	  tst-extvalue
+	  tst-comments
           tst-getconfdirs1
           tst-getconfdirs2
           tst-getconfdirs3
@@ -40,6 +44,7 @@
           tst-getconfdirs5
           tst-getconfdirs6
           tst-getconfdirs7
+	  tst-without-suffix
           tst-econf_errstring1
           tst-setgetvalues1
           tst-groups1
@@ -48,8 +53,19 @@
           tst-groups4
           tst-parseconfig1
           tst-quote1
-          )
+	  tst-parse-error
+	  tst-getpath
+	  tst-write-string-data
+	  tst-write-comments )
 
 foreach (TESTCASE ${TESTS})
   BuildAndAddTest(${TESTCASE})
 endforeach()
+
+find_program (BASH_PROGRAM bash)
+
+if (BASH_PROGRAM)
+    add_test (econftool1 ${BASH_PROGRAM} ${CMAKE_CURRENT_SOURCE_DIR}/tst-econftool1.sh)
+    add_test (econftool_show1 ${BASH_PROGRAM} ${CMAKE_CURRENT_SOURCE_DIR}/tst-econftool_show1.sh)
+    add_test (econftool_cat ${BASH_PROGRAM} ${CMAKE_CURRENT_SOURCE_DIR}/tst-econftool_cat.sh)
+endif (BASH_PROGRAM)

=== debian/changelog ===
libeconf (0.4.6+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Add debian/patches/werror.patch (Closes: #1015485, #1014604)

 -- Andreas Henriksson <andreas@fatal.se>  Tue, 16 Aug 2022 07:09:20 +0200

libeconf (0.4.4+dfsg1-1) unstable; urgency=medium

  * Add superficial autopkgtest of libeconf-dev
  * Call into library in libeconf-dev autopkgtest
  * debian/gbp.conf: set upstream branch name
  * debian/gbp.conf: Fix upstream-vcs-tag setting
  * debian/copyright: Add format 1.0 header
  * debian/copyright: Exclude docs for jquery.js
  * debian/watch: Add +dfsg1 suffix to modified orig tarball
  * debian/gbp.conf: Add note about #968329
    - upstream-vcs-tag will need to be manually specified
      because of the +dfsg1 suffix until #968329 gets fixed.
  * Import new upstream release (v0.4.4)
    - gbp import-orig --uscan --upstream-vcs-tag=v0.4.4
  * debian/copyright: Bump copyright year
  * libeconf-dev: Install libeconf(3) manpage
  * libeconf-utils: New binary package for econftool
  * Add doxygen build-dep for html doc generation
  * debian/rules: Manually install doxygen html docs
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository, Repository-Browse.

 -- Andreas Henriksson <andreas@fatal.se>  Sat, 05 Feb 2022 23:23:22 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: libeconf
 Priority: optional
 Maintainer: Andreas Henriksson <andreas@fatal.se>
-Build-Depends: debhelper-compat (= 13), meson
+Build-Depends: debhelper-compat (= 13), meson, doxygen <!nodoc>
 Standards-Version: 4.5.0
 Section: libs
 Homepage: https://github.com/openSUSE/libeconf
@@ -48,3 +48,24 @@
  processed in lexicographic order of their filename.
  .
  This package provides the library files needed at runtime.
+
+Package: libeconf-utils
+Section: utils
+Architecture: any
+Multi-Arch: foreign
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: parse and manage key=value configuration files - command line utils
+ libeconf is a highly flexible and configureable library to parse and manage
+ key=value configuration files. It reads configuration file snippets from
+ different directories and builds the final configuration file for the
+ application from it.
+ .
+ The first file is the vendor provided configuration file. There are two
+ methods of overriding this vendor settings: copy the file from /usr/vendordir
+ to /etc and modify the settings. Alternatively, a directory named
+ file.suffix.d/ within /etc can be created, with drop-in files in the form
+ name.suffix. This files contain only the changes of the specific settings the
+ user is interested in. There can be several such drop-in files, they are
+ processed in lexicographic order of their filename.
+ .
+ This package provides command line utilities (econftool).

## libeconf 0.5.1%2Bdfsg1

=== debian/changelog ===
libeconf (0.5.1+dfsg1-1+deb12u1) bookworm; urgency=medium

  * Cherry-pick upstream buffer overflow fix (Closes: #1037333)
    - CVE-2023-32181
    - CVE-2023-22652

 -- Andreas Henriksson <andreas@fatal.se>  Mon, 10 Feb 2025 21:04:57 +0100

libeconf (0.5.1+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Andreas Henriksson <andreas@fatal.se>  Sat, 18 Feb 2023 20:15:37 +0100

libeconf (0.5.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Update standards version to 4.6.1, no changes needed.
  * debian/libeconf0.symbols: Track library symbols

 -- Andreas Henriksson <andreas@fatal.se>  Sat, 17 Dec 2022 18:32:58 +0100

libeconf (0.4.9+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Andreas Henriksson <andreas@fatal.se>  Sat, 26 Nov 2022 14:22:34 +0100

libeconf (0.4.7+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Revert "Add debian/patches/werror.patch"
    - fixed upstream.

 -- Andreas Henriksson <andreas@fatal.se>  Sun, 16 Oct 2022 19:24:25 +0200

## libeconf 0.5.1+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Ensure built-in policies from CMake are used, (e.g. improved policies for macOS)
 cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
 
-project(libeconf VERSION 0.3.8
+project(libeconf VERSION 0.5.1
                  DESCRIPTION "Enhanced config file parser, which merges config files placed in several locations into one."
                  LANGUAGES C
                  )
@@ -64,6 +64,8 @@
 
 add_subdirectory(lib)
 add_subdirectory(example)
+add_subdirectory(util)
+add_subdirectory(doc)
 
 # Enable testing
 include(CTest)

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,11 @@
 # Create the library
 set(econf_SRCS libeconf.c
+               libeconf_ext.c
                getfilecontents.c
                mergefiles.c
                helpers.c
                keyfile.c
-               econf_errString.c
+               econf_error.c
                get_value_def.c
                )
 
@@ -15,7 +16,8 @@
                keyfile.h
                )
 
-add_library(econf SHARED ${econf_SRCS} ${econf_HDRS} "${PROJECT_SOURCE_DIR}/include/libeconf.h")
+add_library(econf SHARED ${econf_SRCS} ${econf_HDRS}
+               "${PROJECT_SOURCE_DIR}/include/libeconf.h" "${PROJECT_SOURCE_DIR}/include/libeconf_ext.h")
 
 target_include_directories(econf PUBLIC
   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
@@ -28,7 +30,7 @@
   COMPILE_FLAGS "-D_REENTRANT=1"
   C_STANDARD 11
   C_STANDARD_REQUIRED ON
-  PUBLIC_HEADER "${PROJECT_SOURCE_DIR}/include/libeconf.h"
+  PUBLIC_HEADER "${PROJECT_SOURCE_DIR}/include/libeconf.h;${PROJECT_SOURCE_DIR}/include/libeconf_ext.h"
   LINK_FLAGS "-Wl,--no-undefined -Wl,--version-script,\"${PROJECT_SOURCE_DIR}/lib/libeconf.map\""
 )

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Maintainer: Andreas Henriksson <andreas@fatal.se>
 Build-Depends: debhelper-compat (= 13), meson, doxygen <!nodoc>
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Section: libs
 Homepage: https://github.com/openSUSE/libeconf
 Vcs-Browser: https://salsa.debian.org/debian/libeconf

## libeconf 0.5.2+dfsg1

=== debian/changelog ===
libeconf (0.5.2+dfsg1-1) unstable; urgency=medium

  * New upstream release. (Closes: #1037333)
    - includes fixes for CVE-2023-32181 and CVE-2023-22652
  * Add one new symbol to debian/libeconf0.symbols

 -- Andreas Henriksson <andreas@fatal.se>  Sun, 11 Jun 2023 22:01:24 +0200

## libeconf 0.6.0+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Ensure built-in policies from CMake are used, (e.g. improved policies for macOS)
 cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
 
-project(libeconf VERSION 0.5.1
+project(libeconf VERSION 0.6.0
                  DESCRIPTION "Enhanced config file parser, which merges config files placed in several locations into one."
                  LANGUAGES C
                  )
@@ -38,20 +38,20 @@
 
 # Build Types
 set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE}
-    CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel SanitizeAddress RelWithDebInfoStrict"
+    CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel Sanitize RelWithDebInfoStrict"
     FORCE
     )
 
 # AddressSanitize
-set(CMAKE_C_FLAGS_SANITIZEADDRESS
-    "-O2 -g -Wall -fsanitize=address -fno-optimize-sibling-calls -fsanitize-address-use-after-scope -fno-omit-frame-pointer"
-    CACHE STRING "Flags used by the C compiler during AddressSanitizer builds."
+set(CMAKE_C_FLAGS_SANITIZE
+    "-O2 -g -Wall -fsanitize=address,undefined"
+    CACHE STRING "Flags used by the C compiler during Sanitizer builds."
     FORCE
     )
 
-set(CMAKE_LINK_FLAGS_SANITIZEADDRESS
-    "-fsanitize=address"
-    CACHE STRING "Flags used by the linker during AddressSanitizer builds."
+set(CMAKE_LINK_FLAGS_SANITIZE
+    "-fsanitize=address,undefined"
+    CACHE STRING "Flags used by the linker during Sanitizer builds."
     FORCE
     )

=== debian/changelog ===
libeconf (0.6.0+dfsg1-1) unstable; urgency=medium

  * debian/gbp.conf: Rename debian branch
  * New upstream release.
  * Cherry-pick upstream test fix commit
  * Update libeconf0.symbols with additions

 -- Andreas Henriksson <andreas@fatal.se>  Mon, 11 Dec 2023 09:06:03 +0100

## libeconf 0.6.1+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Ensure built-in policies from CMake are used, (e.g. improved policies for macOS)
 cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
 
-project(libeconf VERSION 0.6.0
+project(libeconf VERSION 0.6.1
                  DESCRIPTION "Enhanced config file parser, which merges config files placed in several locations into one."
                  LANGUAGES C
                  )

=== debian/changelog ===
libeconf (0.6.1+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Revert "Cherry-pick upstream test fix commit"
    - now part of upstream release.

 -- Andreas Henriksson <andreas@fatal.se>  Mon, 29 Jan 2024 09:38:12 +0100

## libeconf 0.6.3+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Ensure built-in policies from CMake are used, (e.g. improved policies for macOS)
 cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
 
-project(libeconf VERSION 0.6.1
+project(libeconf VERSION 0.6.2
                  DESCRIPTION "Enhanced config file parser, which merges config files placed in several locations into one."
                  LANGUAGES C
                  )

=== debian/changelog ===
libeconf (0.6.3+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * List static library in debian/not-installed

 -- Andreas Henriksson <andreas@fatal.se>  Tue, 14 May 2024 12:40:33 +0200

## libeconf 0.7.4+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Ensure built-in policies from CMake are used, (e.g. improved policies for macOS)
 cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
 
-project(libeconf VERSION 0.6.2
+project(libeconf VERSION 0.7.4
                  DESCRIPTION "Enhanced config file parser, which merges config files placed in several locations into one."
                  LANGUAGES C
                  )

=== debian/changelog ===
libeconf (0.7.4+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Bump policy compatibility to 4.7.0

 -- Andreas Henriksson <andreas@fatal.se>  Sat, 28 Sep 2024 11:51:15 +0200

libeconf (0.7.2+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Update debian/libeconf0.symbols with new addition

 -- Andreas Henriksson <andreas@fatal.se>  Sun, 18 Aug 2024 01:13:04 +0200

## libeconf 0.7.6+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Ensure built-in policies from CMake are used, (e.g. improved policies for macOS)
 cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
 
-project(libeconf VERSION 0.7.4
+project(libeconf VERSION 0.7.6
                  DESCRIPTION "Enhanced config file parser, which merges config files placed in several locations into one."
                  LANGUAGES C
                  )

=== debian/changelog ===
libeconf (0.7.6+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Andreas Henriksson <andreas@fatal.se>  Fri, 20 Dec 2024 11:07:54 +0100

libeconf (0.7.5+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Andreas Henriksson <andreas@fatal.se>  Mon, 09 Dec 2024 20:45:54 +0100

## libeconf 0.7.7%2Bdfsg1

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Maintainer: Andreas Henriksson <andreas@fatal.se>
 Build-Depends: debhelper-compat (= 13), meson, doxygen <!nodoc>
-Standards-Version: 4.6.1
+Standards-Version: 4.7.0
 Section: libs
 Homepage: https://github.com/openSUSE/libeconf
 Vcs-Browser: https://salsa.debian.org/debian/libeconf

## libeconf 0.7.7+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Ensure built-in policies from CMake are used, (e.g. improved policies for macOS)
 cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
 
-project(libeconf VERSION 0.7.6
+project(libeconf VERSION 0.7.7
                  DESCRIPTION "Enhanced config file parser, which merges config files placed in several locations into one."
                  LANGUAGES C
                  )

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -7,6 +7,7 @@
                keyfile.c
                econf_error.c
                get_value_def.c
+	       readconfig.c
                )
 
 set(econf_HDRS defines.h
@@ -14,6 +15,7 @@
                mergefiles.h
                helpers.h
                keyfile.h
+	       readconfig.h
                )
 
 add_library(econf SHARED ${econf_SRCS} ${econf_HDRS}

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -12,6 +12,8 @@
   if (${TESTNAME} STREQUAL "tst-getconfdirs1")
     target_compile_options(${TESTNAME} PRIVATE -DTESTSDIR=\"${PROJECT_SOURCE_DIR}/tests/\" -DSUFFIX=\".conf\")
   elseif (${TESTNAME} STREQUAL "tst-getconfdirs2")
+    target_compile_options(${TESTNAME} PRIVATE -DTESTSDIR=\"${PROJECT_SOURCE_DIR}/tests/\" -DSUFFIX=\"conf\")
+  elseif (${TESTNAME} STREQUAL "tst-getconfdirs8")
     target_compile_options(${TESTNAME} PRIVATE -DTESTSDIR=\"${PROJECT_SOURCE_DIR}/tests/\" -DSUFFIX=\"conf\")
   else()
     target_compile_options(${TESTNAME} PRIVATE -DTESTSDIR=\"${PROJECT_SOURCE_DIR}/tests/\")
@@ -35,8 +37,15 @@
           tst-arguments5
 	  tst-string
 	  tst-string-append
+	  tst-long-name
+	  tst-security
+	  tst-checkfiles
+	  tst-delimiter-comment
 	  tst-extvalue
 	  tst-comments
+	  tst-python
+	  tst-options
+	  tst-man-dir
           tst-getconfdirs1
           tst-getconfdirs2
           tst-getconfdirs3
@@ -44,6 +53,7 @@
           tst-getconfdirs5
           tst-getconfdirs6
           tst-getconfdirs7
+          tst-getconfdirs8
 	  tst-without-suffix
           tst-econf_errstring1
           tst-setgetvalues1
@@ -68,4 +78,5 @@
     add_test (econftool1 ${BASH_PROGRAM} ${CMAKE_CURRENT_SOURCE_DIR}/tst-econftool1.sh)
     add_test (econftool_show1 ${BASH_PROGRAM} ${CMAKE_CURRENT_SOURCE_DIR}/tst-econftool_show1.sh)
     add_test (econftool_cat ${BASH_PROGRAM} ${CMAKE_CURRENT_SOURCE_DIR}/tst-econftool_cat.sh)
+    add_dependencies(check econftool)
 endif (BASH_PROGRAM)

=== debian/changelog ===
libeconf (0.7.7+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Andreas Henriksson <andreas@fatal.se>  Mon, 20 Jan 2025 19:13:17 +0100

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@ --buildsystem=meson

execute_after_dh_installdocs:
ifneq (nodoc,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
	cp -av $(CURDIR)/obj-*/doc/html $(CURDIR)/debian/libeconf-dev/usr/share/doc/libeconf-dev/
endif

=== debian/tests/control ===
Tests: libeconf-dev
Depends: libeconf-dev, pkg-config, build-essential
Restrictions: superficial

## libeconf 0.7.9+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Ensure built-in policies from CMake are used, (e.g. improved policies for macOS)
 cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
 
-project(libeconf VERSION 0.7.7
+project(libeconf VERSION 0.7.9
                  DESCRIPTION "Enhanced config file parser, which merges config files placed in several locations into one."
                  LANGUAGES C
                  )

=== doc/CMakeLists.txt ===
# add a target to generate API documentation with Doxygen
find_package(Doxygen)
option(BUILD_DOCUMENTATION "Create and install the HTML based API documentation (requires Doxygen)" ${DOXYGEN_FOUND})

if(BUILD_DOCUMENTATION)
    if(NOT DOXYGEN_FOUND)
        message(FATAL_ERROR "Doxygen is needed to build the documentation.")
    endif()

    set(doxyfile_in ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in)
    set(doxyfile ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

    configure_file(${doxyfile_in} ${doxyfile} @ONLY)

    add_custom_target(doc
        COMMAND ${DOXYGEN_EXECUTABLE} ${doxyfile}
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMENT "Generating API documentation with Doxygen"
        VERBATIM)

    install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/../html DESTINATION share/doc)
endif()

install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/libeconf.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_comment_tag.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_delimiter_tag.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_errLocation.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_errString.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_freeArray.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_freeExtValue.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_freeFile.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_getBoolValue.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_getExtValue.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_getFloatValue.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_getGroups.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_getIntValue.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_getKeys.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_getPath.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_getStringValue.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_mergeFiles.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_newIniFile.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_newKeyFile.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_readConfig.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_readConfigWithCallback.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_readFile.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_readFileWithCallback.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_setBoolValue.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_set_comment_tag.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_set_conf_dirs.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_set_delimiter_tag.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_setFloatValue.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_setIntValue.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_setStringValue.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econf_writeFile.3 DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/man/econftool.8 DESTINATION ${CMAKE_INSTALL_MANDIR}/man8)

=== example/CMakeLists.txt ===
# Create the binary/executable
add_executable(example EXCLUDE_FROM_ALL example.c)
target_compile_options(example PRIVATE -DDEXAMPLEDIR=\"${PROJECT_SOURCE_DIR}/example/\")
target_link_libraries(example PRIVATE econf)

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -33,7 +33,7 @@
   C_STANDARD 11
   C_STANDARD_REQUIRED ON
   PUBLIC_HEADER "${PROJECT_SOURCE_DIR}/include/libeconf.h;${PROJECT_SOURCE_DIR}/include/libeconf_ext.h"
-  LINK_FLAGS "-Wl,--no-undefined -Wl,--version-script,\"${PROJECT_SOURCE_DIR}/lib/libeconf.map\""
+  LINK_FLAGS "-Wl,--no-undefined -Wl,--no-undefined-version -Wl,--version-script,\"${PROJECT_SOURCE_DIR}/lib/libeconf.map\""
 )
 
 # Install the library

=== debian/changelog ===
libeconf (0.7.9+dfsg1-1) experimental; urgency=medium

  * New upstream release.

 -- Andreas Henriksson <andreas@fatal.se>  Sun, 11 May 2025 00:38:13 +0200
